"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactJss = require("react-jss");

var _formTemplate = _interopRequireDefault(require("@data-driven-forms/common/form-template"));

var _buttons = require("@blueprintjs/core/lib/cjs/components/button/buttons.js");

var _html = require("@blueprintjs/core/lib/cjs/components/html/html.js");

var _blueprintContext = _interopRequireDefault(require("../blueprint-context/blueprint-context"));

var Form = function Form(_ref) {
  var children = _ref.children,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["children"]);
  return /*#__PURE__*/_react["default"].createElement("form", (0, _extends2["default"])({
    noValidate: true
  }, props, {
    style: {
      display: 'grid'
    }
  }), children);
};

Form.propTypes = {
  children: _propTypes["default"].node
};
var useStyles = (0, _reactJss.createUseStyles)({
  buttonGroup: {
    marginTop: 16,
    '& button:not(:first-child)': {
      marginLeft: 8
    }
  }
});

var ButtonGroup = function ButtonGroup(_ref2) {
  var children = _ref2.children,
      props = (0, _objectWithoutProperties2["default"])(_ref2, ["children"]);

  var _useStyles = useStyles(),
      buttonGroup = _useStyles.buttonGroup;

  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    className: buttonGroup
  }, props), children);
};

ButtonGroup.propTypes = {
  children: _propTypes["default"].node
};

var Title = function Title(_ref3) {
  var children = _ref3.children,
      props = (0, _objectWithoutProperties2["default"])(_ref3, ["children"]);
  return /*#__PURE__*/_react["default"].createElement(_html.H1, props, children);
};

Title.propTypes = {
  children: _propTypes["default"].node
};

var Description = function Description(_ref4) {
  var children = _ref4.children,
      props = (0, _objectWithoutProperties2["default"])(_ref4, ["children"]);
  return /*#__PURE__*/_react["default"].createElement(_html.H2, props, children);
};

Description.propTypes = {
  children: _propTypes["default"].node
};

var InnerButton = function InnerButton(_ref5) {
  var label = _ref5.label,
      buttonType = _ref5.buttonType,
      props = (0, _objectWithoutProperties2["default"])(_ref5, ["label", "buttonType"]);
  return /*#__PURE__*/_react["default"].createElement(_buttons.Button, (0, _extends2["default"])({
    intent: buttonType === 'submit' ? 'success' : ''
  }, props), label);
};

InnerButton.propTypes = {
  children: _propTypes["default"].node,
  label: _propTypes["default"].node,
  buttonType: _propTypes["default"].string
};

var BlueprintFormTemplate = function BlueprintFormTemplate(_ref6) {
  var requiredLabelInfo = _ref6.requiredLabelInfo,
      props = (0, _objectWithoutProperties2["default"])(_ref6, ["requiredLabelInfo"]);
  return /*#__PURE__*/_react["default"].createElement(_blueprintContext["default"].Provider, {
    value: {
      required: requiredLabelInfo || /*#__PURE__*/_react["default"].createElement("span", {
        className: "bp3-text-muted"
      }, "(required)")
    }
  }, /*#__PURE__*/_react["default"].createElement(_formTemplate["default"], (0, _extends2["default"])({
    FormWrapper: Form,
    Button: InnerButton,
    ButtonGroup: ButtonGroup,
    Title: Title,
    Description: Description
  }, props)));
};

BlueprintFormTemplate.propTypes = {
  requiredLabelInfo: _propTypes["default"].node
};
var _default = BlueprintFormTemplate;
exports["default"] = _default;